#!/usr/bin/env bash

if [ -z $1 ]; then
	echo "usage: $0 {test host}"
	exit 1
fi

TESTHOST=$1


KEYTAB_FILE="/daq_area/castor/$TESTHOST/atlascdr/atlascdr.keytab"
if ! ssh $TESTHOST "sudo -u atlascdr -i cat $KEYTAB_FILE &>/dev/null"; then
	echo "error: keytab file not readble by atlascdr ($KEYTAB_FILE)"
	exit 3
else
	echo "OK: readable keytab file: $KEYTAB_FILE"
fi

SOURCE_DIR=`pwd`/..
TOOLS_DIR=`pwd`/../../flegoff/castor_tools

echo "sending signal 12 to CastorScripts at $TESTHOST"
ssh $TESTHOST sudo -u atlascdr -i $TOOLS_DIR/signal-script.sh 12
