import subprocess

def migrated(filename, stager, logger=None):
    cmd = [ 'xrdfs'
          , 'root://{}'.format(stager)
          , 'stat'
          , '-q'
          , 'BackUpExists'
          , filename
          ]
    sp = subprocess.Popen(cmd, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    ret = sp.wait()
    output = sp.stdout.read()

    if logger:
        logger.debug(output)

    return (ret == 0)

def listdir(directory, stager, logger=None):
    cmd = [ 'xrdfs'
          , 'root://{}'.format(stager)
          , 'ls'
          , directory
          ]
    sp = subprocess.Popen(cmd, stdout=subprocess.PIPE, stderr=subprocess.STDOUT)
    output, _ = sp.communicate()
    ret = sp.wait()

    if logger:
        logger.debug(output)

    return ((ret == 0), [f for f in output.split('\n') if f])

if __name__ == '__main__':
    import sys
    if len(sys.argv) < 4 or (sys.argv[1] != 'mig' and sys.argv[1] != 'ls'):
        print('usage: {} {{mig|ls}} stager file'.format(sys.argv[1]))
        sys.exit(1)
    mcmd = sys.argv[1]
    mstager = sys.argv[2]
    mpath = sys.argv[3]

    if mcmd == 'mig':
        if migrated(mpath, mstager, None):
            print('File {} exists on tape'.format(mpath))
        else:
            print('File {} does not exist on tape'.format(mpath))
    elif mcmd == 'ls':
        print(listdir(mpath, mstager))
