#!/bin/env python
from __future__ import print_function
from builtins import object
import os.path
import cs.StorageBackends.ctastorage as ctastorage

def init(configuration):
    testmigrated = TestLookup(configuration["stagehost"],
                            configuration["basedir"])

    globals()['TestMigrated'] = testmigrated._testMigrated #pylint: disable=protected-access


class TestLookup(object):

    def __init__(self, stagehost, basedir):
        self.stagehost = stagehost
        self.basedir = basedir

    def _testMigrated(self, filename, stagehost, pool, backend,
                     logger=None, verbose=False):
        del stagehost, pool, backend, verbose # unused args

        # we don't need this step here but it used by DDMMigrated
        # so I still call it to test it somehow
        _, _ = ctastorage.listdir(self.basedir, self.stagehost, logger)

        return ctastorage.migrated(os.path.join(self.basedir, filename), self.stagehost, logger)


if __name__ == '__main__':

    def _parseargs():
        import argparse

        parser = argparse.ArgumentParser(
                description='test migration checker',
                formatter_class=argparse.ArgumentDefaultsHelpFormatter)

        parser.add_argument('-s', '--stagehost', default='eosctaatlaspps')
        parser.add_argument('-b', '--basedir', default='/eos/ctaatlaspps/daqtest/')
        parser.add_argument('-f', '--file', required=True)

        return parser.parse_args()

    args = _parseargs()

    config = {'stagehost':args.stagehost,
              'basedir':args.basedir}

    init(config)

    # pylint cannot find dynamically-added global function
    print(TestMigrated(args.file, None, None, #pylint: disable=E0602
                      None, verbose=True))
