from builtins import str
from builtins import object
import time
from subprocess import Popen, PIPE
#For timing timeouts, timer starts with __init__ function
class Timer(object):
    def __init__(self, seconds):
        self.startTime = time.time()
        self.endTime = self.startTime + seconds
        self.timedout = False
    
    def timesUp(self):
        if (self.endTime < time.time()): 
            self.timedout = True
            return True
        else: 
            return False

    def timesNotUp(self):
        return not self.timesUp()

def createTmpDir(testLocation):
    """Creates the directories: tmp, des, src and log at the defined testLocation. 
    Testlocation is the relative path from the CastorScript folder to where the folders should be created.
    returns a dictionary of paths to relevant directories: projectPath, configPath, tmpPath, srcPath, desPath and logPath."""
    import os, shutil

    dirs = {}

    ## Define folder structure
    dirs["project"] = os.path.dirname(os.path.abspath(__name__))
    
    thisDir = dirs["project"] + testLocation

    dirs["tmp"] = thisDir + "/tmp"
    dirs["config"] = dirs["project"] + "/Configs"

    dirs["src"] = dirs["tmp"] + "/src"
    dirs["des"] = dirs["tmp"] + "/des"
    dirs["log"] = dirs["tmp"] + "/log"

    # I create some folders
    try:
        os.makedirs(dirs["src"])
        os.makedirs(dirs["des"])
        os.makedirs(dirs["log"])
    except:
        shutil.rmtree(dirs["tmp"])
        os.makedirs(dirs["src"])
        os.makedirs(dirs["des"])
        os.makedirs(dirs["log"])

    return dirs



class DirectoryChecker(object):
    """For checking the contents of a directory either once, or until a condition is met or timeout is reached."""
    def __init__(self, dirPath):
        self.dirPath = dirPath
        self.lsOutput = None
        self.wasEmpty = None
        self.timerUtil = None

    def waitForAnyFile(self, seconds):
        "Waits for the specified amount of time for the dir to be empty, returns a tuple (bool: timedout, str: lsOutput)"
        self.timerUtil = Timer(seconds)
        while self.checkIfEmpty() and self.timerUtil.timesNotUp():
            pass
        return (self.timerUtil.timedout, self.getLsOutput())

    def waitForEmptyDir(self, seconds):
        "Waits for the specified amount of time for the dir to contain files, returns a tuple (bool: timedout, str: lsOutput)"
        self.timerUtil = Timer(seconds)
        while self.checkIfNotEmpty() and self.timerUtil.timesNotUp():
            pass
        return (self.timerUtil.timedout, self.getLsOutput())

    def checkIfEmpty(self):
        if len(self.getLsOutput()) > 1:
            self.wasEmpty = False
            return False
        else:
            self.wasEmpty = True
            return True

    def checkIfNotEmpty(self):
        return not self.checkIfEmpty()

    def checkIfContains(self, substring):
        if self.getLsOutput().find(substring) > -1:
            return True
        else: 
            return False
        
    def getLsOutput(self):
        self.lsOutput = str(Popen(["ls", self.dirPath],bufsize=-1, stdout=PIPE).communicate()[0])
        return self.lsOutput