#!/bin/bash
# Warning dragons be here:
# this script is intended to run in a docker image with the following command:
# sudo docker run -it --privileged -v `pwd`:`pwd` -w `pwd` -v /cvmfs:/cvmfs:shared,ro -v /afs:/afs:ro --rm=true gitlab-registry.cern.ch/atlas-tdaq-software/tdaq_ci:centos7 bash ./run_unit_tests.sh
TOPDIR=$(cd `dirname $0` && echo `pwd`"/Script" )
STARTDIR=$(echo $TOPDIR"/UnitTests")

if ! [ -v TDAQ_LCG_RELEASE ]
then
    source /afs/cern.ch/atlas/project/tdaq/cmake/cmake_tdaq/bin/cm_setup.sh nightly
fi

#python -m unittest discover -t $TOPDIR -s $STARTDIR -p "*Test.py"  -f --verbose
python UnitTests/TestSuite_UnitTests.py
python UnitTests/TestSuite_Functional.py

#for Gitlab CI we just find all files in unittest dir, as we just care if it fails or not, the setup above is only for local testing
# python -m unittest discover --top-level-directory "Script/" --start-directory "Script/UnitTests/" --pattern "*Test.py" --verbose