#!/bin/bash
if grep -i centos /etc/redhat-release &>/dev/null; then
	TDAQ_RELEASE=tdaq-08-03-01
	echo "setting up environment for centos, tdaq release: $TDAQ_RELEASE"
	source /sw/tdaq/setup/setup_$TDAQ_RELEASE.sh

	# Add path for xrdcp binary matching this release
	export PATH="$LCG_INST_PATH/$TDAQ_LCG_RELEASE/xrootd/4.9.1/$CMTCONFIG/bin/:$PATH"
	# Extend python path for externals (mailinglogger)
	export PYTHONPATH="$PYTHONPATH:/sw/atlas/tdaq/$TDAQ_LCG_RELEASE/installed/external/$CMTCONFIG/lib/python2.7/site-packages/"
else
	TDAQ_RELEASE=tdaq-07-01-00
	echo "setting up environment for slc, tdaq release: $TDAQ_RELEASE"
	source /sw/tdaq/setup/setup_$TDAQ_RELEASE.sh

	# Add path for xrdcp binary matching this release
	export PATH="$LCG_INST_PATH/LCG_87/xrootd/4.4.1/$CMTCONFIG/bin/:$PATH"
	# Extend python path for externals:
	#   mailinglogger
	CASTOR_SCRIPT_DIR=$(readlink -f `dirname $BASH_SOURCE`)
	export PYTHONPATH="$CASTOR_SCRIPT_DIR/external:$PYTHONPATH"
	#   python future
	export PYTHONPATH="$PYTHONPATH:/sw/atlas/sw/lcg/releases/LCG_87/future/0.15.2/x86_64-slc6-gcc62-opt/lib/python2.7/site-packages/"
fi

